#include <stdio.h>
//#include <curses.h>

#include <sys/types.h>
#include <dirent.h>
#include <sys/stat.h>
#include <unistd.h>
#include <unistd.h>
#include <pwd.h>

#include <string>
#include <string.h>
#include <vector>

#define STRING std::string

extern int errno;
//extern char **environ;

STRING int2str( int what)
{
	if( what <= 0)
		return "0";

	STRING retval,temp;

	while( what)
	{
		temp += ('0' + what - ((what / 10) * 10));
		what /= 10;
	}

	for( int i = temp.size() - 1; i >= 0; i--)
		retval += temp[i];

	return retval;
}

int ls( int argv, char ** args)
{
//	printf("%d\n", argv);
//	printw("HERE 0\n");

	std::vector<STRING> dirs;
	STRING mypath;
	bool recursive = false;
	struct stat * status = new struct stat;
	char temp[200];
	int temp2;

//	printw("HERE 1\n");

	if( argv == 2)
	{
		if( strcmp( args[1], "-R") == 0)
		{
			mypath = getcwd( temp, temp2);
			recursive = true;
		}
		else
			mypath = args[1];
	}else if( argv == 1)
//	{
		mypath = getcwd( temp, temp2);
//		printf( "%s", mypath.c_str());
	else if( argv == 3 && strcmp( args[2], "-R") == 0)
	{
		mypath = args[1];
		recursive = true;
	}else
		return -1;
	
	if( mypath[mypath.size() - 1] != '/')
		dirs.push_back( mypath + "/");
	else
		dirs.push_back( mypath);

//	printw("HERE 2\n");

	while( !dirs.empty())
	{
		mypath = dirs[0];
		dirs.erase( dirs.begin());
		printf("\n\t%s\n\n", mypath.c_str());
		
		STRING temp;
		DIR * mydir = opendir( mypath.c_str());

		if( mydir == NULL)
		{
			printf("The directory is not exist!!\n");
			continue;
//			return 0;
		}
	
		dirent * myent;

//		if( mydir == NULL)
//			return 0;	
	
		do{
			if ( (myent = readdir( mydir)) == 0)
//			{
//				printf("Directory problem\n");
				break;
//			}

			if( stat( (mypath + myent->d_name).c_str(), status) == -1)
			{
//				printw("Status problem %d\n", errno);
				continue;
			}
			
//			printw("%d\n", (int)myent->d_type);
			
			if( S_ISREG( status->st_mode))
				temp = "-";
			else if( S_ISLNK( status->st_mode))
				temp = "l";
			else if( S_ISDIR( status->st_mode))
			{
				if( strcmp( myent->d_name, ".") != 0 && strcmp( myent->d_name, "..") != 0)
					dirs.push_back( mypath + myent->d_name + "/");

//				printf("---------%d---------", dirs.size());
				
				temp = "d";
			}else if( S_ISCHR( status->st_mode))
				temp = "c";
			else if( S_ISBLK( status->st_mode))
				temp = "b";
			else if( S_ISSOCK( status->st_mode))
				temp = "s";
			else if( S_ISFIFO( status->st_mode))
				temp = "f";

			if( S_IRUSR & status->st_mode)
				temp += "r";
			else
				temp += "-";

			if( S_IWUSR & status->st_mode)
				temp += "w";
			else
				temp += "-";

			if( S_IXUSR & status->st_mode)
				temp += "x";
			else
				temp += "-";

			if( S_IRGRP & status->st_mode)
				temp += "r";
			else
				temp += "-";

			if( S_IWGRP & status->st_mode)
				temp += "w";
			else
				temp += "-";

			if( S_IXGRP & status->st_mode)
				temp += "x";
			else
				temp += "-";

			if( S_IROTH & status->st_mode)
				temp += "r";
			else
				temp += "-";

			if( S_IWOTH & status->st_mode)
				temp += "w";
			else
				temp += "-";

			if( S_IXOTH & status->st_mode)
				temp += "x    ";
			else
				temp += "-    ";

//			temp += int2str( status->st_nlink);
//			temp += "\t";
			temp += getpwuid( status->st_uid)->pw_name;
			temp += "\t";
			printf("%s", temp.c_str());
		
//			temp += int2str( status->st_size);
//			temp += "\t";
//
//			if( temp[0] == 'd')
//				attrset( COLOR_PAIR( 5) | A_BOLD);
//			else if( temp[0] == 'l')
//				attrset( COLOR_PAIR( 7) | A_BOLD);
//			else if( temp[0] == '-' && temp[3] == 'x')
//				attrset( COLOR_PAIR( 3) | A_BOLD);
				
			printf("%s\n", myent->d_name);

//			attrset( COLOR_PAIR( 8));
			
		}while( myent != NULL);
	
		if( closedir( mydir) == -1)
			printf("Directory isn't closed!!\n");

		if( !recursive)
			break;
	}

	delete status;
	
	return 0;
}
